#include <bits/stdc++.h>
#include "popa.h"

using namespace std;

const int MaxN = 1010;

int lf[MaxN], rg[MaxN];

int dfs(int l, int r) {
	if (l > r) return -1;
	int st = l, dr = r;
	while (st <= dr) {
		int mid = (st + dr) / 2;
		if (query(l, r, l, mid)) dr = mid - 1;
		else st = mid + 1;
	}
	lf[st] = dfs(l, st - 1);
	rg[st] = dfs(st + 1, r);
	return st;
}

int solve(int n, int* left, int* right) {
	int root = dfs(0, n - 1);
	for (int i = 0; i < n; i++) {
		left[i] = lf[i];
		right[i] = rg[i];
	}
	return root;
}
